/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

import {postForm} from 'frontend-js-web';

export default function propsTransformer({
	additionalProps: {deleteRedirectEntriesURL},
	portletNamespace,
	...otherProps
}) {
	return {
		...otherProps,
		onActionButtonClick: (event, {item}) => {
			if (item?.data?.action === 'deleteSelectedRedirectEntries') {
				const form = document.getElementById(`${portletNamespace}fm`);

				if (form) {
					postForm(form, {
						data: {
							deleteEntryIds: Liferay.Util.listCheckedExcept(
								form,
								`${portletNamespace}allRowIds`
							),
						},
						url: deleteRedirectEntriesURL,
					});
				}
			}
		},
	};
}
